<template>
	<div class="snapshot-re-send-citizen-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<vxe-grid v-bind="gridOptions" ref="gridRef" @checkbox-all="selectAllChangeEvent" @checkbox-change="selectChangeEvent">
				<template #form>
					<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent :disabled="gridOptions.loading">
						<el-form-item label="发送状态" prop="Status">
							<el-radio-group v-model="state.queryParams.Status" @change="handleQuery">
								<el-radio :value="0">发送成功</el-radio>
								<el-radio :value="1">发送失败</el-radio>
								<el-radio :value="3">婉拒</el-radio>
								<el-radio :value="2">未发送</el-radio>
							</el-radio-group>
						</el-form-item>
						<el-form-item label="工单编码" prop="No">
							<el-input v-model="state.queryParams.No" placeholder="请填写工单编码" clearable @keyup.enter="handleQuery" class="keyword-input" />
						</el-form-item>
						<el-form-item label="手机号" prop="PhoneNumber">
							<el-input
								v-model="state.queryParams.PhoneNumber"
								placeholder="请填写手机号"
								clearable
								@keyup.enter="handleQuery"
								class="keyword-input"
							/>
						</el-form-item>
						<el-form-item>
							<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
							<el-button @click="drawer = true" class="default-button"> <SvgIcon name="ele-Search" class="mr5" />更多查询</el-button>
						</el-form-item>
					</el-form>
				</template>
				<template #toolbar_buttons>
					<el-button
						type="primary"
						@click="onSend"
						v-auth="'snapshot:reSend:citizen:send'"
						:disabled="isChecked"
						:loading="state.loading"
						v-if="state.queryParams.Status === 1"
						>批量发送红包<span v-if="checkTable.length">({{ checkTable.length }})</span>
					</el-button>
				</template>
				<template #order_detail="{ row }">
					<order-detail :order="{ id: row.orderId }" @updateList="queryList">{{ row.no }}</order-detail>
				</template>
				<template #pager>
					<pagination
						@pagination="queryList"
						:total="state.total"
						v-model:current-page="state.queryParams.PageIndex"
						v-model:page-size="state.queryParams.PageSize"
						:disabled="state.loading"
					/>
				</template>
			</vxe-grid>
		</div>
		<!--	更多查询	-->
		<el-drawer v-model="drawer" title="更多查询" size="500px">
			<el-form :model="state.queryParams" ref="drawerRuleFormRef" @submit.native.prevent label-width="100px">
				<el-form-item label="增加时间" prop="zjTime">
					<el-date-picker
						v-model="state.queryParams.zjTime"
						type="datetimerange"
						unlink-panels
						range-separator="至"
						start-placeholder="开始时间"
						end-placeholder="结束时间"
						:shortcuts="shortcuts"
						@change="handleQuery"
						value-format="YYYY-MM-DD[T]HH:mm:ss"
						:default-time="defaultTimeStartEnd"
					/>
				</el-form-item>
			</el-form>
			<template #footer>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(drawerRuleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</template>
		</el-drawer>
	</div>
</template>

<script lang="tsx" setup name="snapshotReSendCitizen">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { defaultTimeStartEnd, shortcuts } from '@/utils/constants';
import { citizenRedEnvelopeApproval, getCitizenRedEnvelopeApprovalList } from '@/api/snapshot/reSend';
import Other from '@/utils/other';
import { knowledgeLexiconDelete } from '@/api/auxiliary/knowledgeLexicon';

// 引入组件
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页
const OrderDetail = defineAsyncComponent(() => import('@/components/OrderDetail/index.vue')); // 工单详情

// 定义变量内容
const state = reactive<any>({
	loading: false,
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 20,
		zjTime: [], // 增加时间
		BeginCreationTime: null,
		EndCreationTime: null,
		Status: 0, // 状态 默认发送成功
		PhoneNumber: null, // 手机号
		No: null, // 工单编号
	},
	total: 0, // 总条数
});

const gridOptions = reactive<any>({
	loading: false,
	border: true,
	showOverflow: true,
	columnConfig: {
		resizable: true,
	},
	scrollY: {
		enabled: true,
		gt: 100,
	},
	toolbarConfig: {
		zoom: true,
		custom: true,
		refresh: {
			queryMethod: () => {
				handleQuery();
			},
		},
		slots: {
			buttons: 'toolbar_buttons',
		},
	},
	customConfig: {
		storage: true,
	},
	id: 'snapshotReSendCitizen',
	rowConfig: { isHover: true, height: 30, isCurrent: true, useKey: true },
	height: 'auto',
	columns: [
		{ type: 'checkbox', width: 50, align: 'center' },
		{
			field: 'no',
			title: '工单编码',
			slots: { default: 'order_detail' },
		},
		{
			field: 'creationTime',
			title: '增加时间',
			formatter: 'formatDate',
		},
		{
			field: 'phoneNumber',
			title: '手机号',
		},
		{
			field: 'amount',
			title: '金额',
		},
		{
			field: 'receiveTime',
			title: '发放时间',
			formatter: 'formatDate',
		},
		{
			field: 'distributionStateTxt',
			title: '状态',
		},
		{
			field: 'pickupStatusTxt',
			title: '领取状态',
		},
		{
			field: 'remark',
			title: '备注',
			minWidth: 200,
		},
	],
	data: [],
});
/** 搜索按钮操作 节流操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
// 获取参数列表
const requestParams = ref<EmptyObjectType>({});
const queryList = () => {
	state.loading = true;
	gridOptions.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.BeginCreationTime = state.queryParams.zjTime === null ? null : state.queryParams.zjTime[0]; // 增加时间
	requestParams.value.EndCreationTime = state.queryParams.zjTime === null ? null : state.queryParams.zjTime[1];
	Reflect.deleteProperty(requestParams.value, 'zjTime'); // 删除无用的参数
	getCitizenRedEnvelopeApprovalList(requestParams.value)
		.then((res) => {
			state.loading = false;
			gridOptions.data = res.result.items ?? [];
			state.total = res.result.total ?? 0;
			gridOptions.loading = false;
			gridRef.value.clearCheckboxRow();
			checkTable.value = [];
		})
		.finally(() => {
			state.loading = false;
			gridOptions.loading = false;
			gridRef.value.clearCheckboxRow();
			checkTable.value = [];
		});
};
// 重置表单
const drawerRuleFormRef = ref<RefType>();
const ruleFormRef = ref<any>(null); // 表单ref
const drawer = ref(false);
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	ruleFormRef.value?.resetFields();
	queryList();
};

const checkTable = ref<EmptyArrayType>([]);
const gridRef = ref<RefType>();
const selectAllChangeEvent = ({ checked }) => {
	if (gridRef.value) {
		const records = gridRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (gridRef.value) {
		const records = gridRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !Boolean(checkTable.value.length);
});

// 批量发送红包
const onSend = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	ElMessageBox.confirm(`您确认要批量发送红包选中的工单？`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			citizenRedEnvelopeApproval(ids).then(() => {
				ElMessage.success('批量发送成功');
				queryList();
			});
		})
		.catch(() => {});
};
// 页面加载时
onMounted(() => {
	queryList();
});
</script>
